#!/bin/sh

echo "BIXOLON CO Ltd"
echo "BIXOLON CUPS DRIVER V1.3.9 Installer"
echo "---------------------------------------"
echo ""
echo ""

ROOT_UID=0

if [ "$UID" -ne "$ROOT_UID" ]
then
    echo "This script requires root user access..."
    echo "Re-run as root user..."
    exit 1
fi

echo "Copying rastertoBixolon_v1.3.9 filter..."

LINUX_CHECK_GENTOO="$(cat /etc/*-release | grep -ic gentoo)"
LINUX_CHECK_RHEL7="$(cat /etc/*-release | grep -ic "Red Hat Enterprise Linux 7")"
NO_GENTOO=0
NO_RHEL7=0

if [ ${LINUX_CHECK_GENTOO} = ${NO_GENTOO} ]
then
LIBPATH="lib"
else
LIBPATH="libexec"
fi

 sudo chmod +x rastertoBixolon_v1.3.9
 sudo cp ./rastertoBixolon_v1.3.9 /usr/bin/
 sudo chmod 0755 /usr/bin/rastertoBixolon_v1.3.9
echo ""

echo "Creating Symbolic Link...."
  sudo ln -s /usr/bin/rastertoBixolon_v1.3.9 /usr/${LIBPATH}/cups/filter/rastertoBixolon
  sudo chmod 0755 /usr/${LIBPATH}/cups/filter/rastertoBixolon

### CUPS VERSION 1.7.2 Has Broken USB backend
if [ ${LINUX_CHECK_RHEL7} = ${NO_RHEL7} ]
then
	CUPSVER="$(cups-config --version)"
	echo "CUPS VERSION: ${CUPSVER}"
	CKVER=1.7.2

	if [ ${CUPSVER} = ${CKVER} ] ;
	then
		echo "Copy usb backend...."
		sudo cp ./CUPS1.7.2/usb /usr/${LIBPATH}/cups/backend/;
		sudo chmod 0755 /usr/${LIBPATH}/cups/backend/usb;
		cp ./CUPS1.7.2/usb /usr/${LIBPATH}/cups/backend-available/;
		sudo chmod 0755 /usr/${LIBPATH}/cups/backend-available/usb;
	fi;
fi

echo ""


if [ -x /etc/init.d/cupsys ]
then
	if [ -r /etc/debian_version ]
	then
		if [ -r /etc/lsb-release ]
		then
			 sudo cp -r ./Bixolon /usr/share/cups/model/
			 sudo chmod 0755 /usr/share/cups/model/Bixolon/*
		else
			 sudo cp ./Bixolon /usr/share/ppd/ 
			 sudo chmod 0755 /usr/share/ppd/Bixolon/*
			 
		fi
	else
		 sudo cp -r ./Bixolon /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/Bixolon/*
		 
	fi
else
	if [ -r /etc/debian_version ]
	then
		 sudo cp -r ./Bixolon /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/Bixolon/*
		
	else
		 sudo cp -r ./Bixolon /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/Bixolon/*
		
	fi
fi 
echo ""

echo "Restarting CUPS"
    if [ -x /etc/software/init.d/cups ]
    then
        sudo /etc/software/init.d/cups stop
        sudo /etc/software/init.d/cups start
    elif [ -x /etc/rc.d/init.d/cups ]
    then
        sudo /etc/rc.d/init.d/cups stop
        sudo /etc/rc.d/init.d/cups start
    elif [ -x /etc/init.d/cups ]
    then
        sudo /etc/init.d/cups stop
        sudo /etc/init.d/cups start
    elif [ -x /sbin/init.d/cups ]
    then
        sudo /sbin/init.d/cups stop
        sudo /sbin/init.d/cups start
    elif [ -x /etc/software/init.d/cupsys ]
    then
        sudo /etc/software/init.d/cupsys stop
        sudo /etc/software/init.d/cupsys start
    elif [ -x /etc/rc.d/init.d/cupsys ]
    then
        sudo /etc/rc.d/init.d/cupsys stop
        sudo /etc/rc.d/init.d/cupsys start
    elif [ -x /etc/init.d/cupsys ]
    then
        sudo /etc/init.d/cupsys stop
        sudo /etc/init.d/cupsys start
    elif [ -x /sbin/init.d/cupsys ]
    then
        sudo /sbin/init.d/cupsys stop
        sudo /sbin/init.d/cupsys start
    elif [ ${LINUX_CHECK_RHEL7} -gt ${NO_RHEL7} ]
    then
	sudo systemctl restart cups.service
    else
        echo "Could not restart CUPS"
    fi

	if [ ${LINUX_CHECK_GENTOO} = ${NO_GENTOO} ]
	then
		if [ ${LINUX_CHECK_RHEL7} -gt ${NO_RHEL7} ]
		then
			sudo systemctl restart cups.service
		else
			sudo service cups stop
			sudo service cups start
		fi
	else
		sudo service cupsd stop
		sudo service cupsd start
	fi

    echo ""


echo "Install Complete"
echo "Add printer queue using OS tool, http://localhost:631, or http://127.0.0.1:631"
echo ""

